$(document).ready(function() {
    var fechaSinFormato = new Date();
    var fechaActual = fechaSinFormato.getFullYear() + "-" + ("0"+(fechaSinFormato.getMonth()+1)).slice(-2) + "-" + ("0" + fechaSinFormato.getDate()).slice(-2);
    envios(fechaActual,fechaActual);
    datePickerRange();
    $('#modalFactura').modal({}); 
}); 

//DatePicker version movil
function datepicker(fechaActual) {
    $("#datePicker").html("");
    var maxDay = "";
    maxDay = `<input class="mdl-textfield__input" type="date" max="${fechaActual}" value="${fechaActual}" id="date">`;
    maxDay += `<label class="mdl-textfield__label" for="date">Filtrar por fecha</label>`;
    $("#datePicker").html(maxDay);
}

function envios(fechaInicio,fechaFin) {
    params = {
        service: 'listaEnvios',
        dbName: dbName,
        idEmpresas: localStorage.idEmpresas,
        idSucursales: localStorage.idSucursales,
        fechaInicio: fechaInicio,
        fechaFin: fechaFin
    };
    $('#dataTable').DataTable().clear().destroy()
    $.post(host, params, function(data) {
        var totalQ = 0;
        var totalDolares = 0;
        var descuentos = 0;
        $.each(data, function(key, val){
            if (val.anulacion == "0"){
            //total += accounting.unformat(val.valorFactura);
            totalQ += accounting.unformat(val.total);
            totalDolares += accounting.unformat(val.totalDolares);
            descuentos += accounting.unformat(val.descuento);
            }
        });

        $('#dataTable').DataTable().clear().destroy()
        $('#dataTable').DataTable({
            responsive: true,
            //fixedColumns: true,
            fixedHeader: true,
            lengthChange: false,
            bDestroy: true,
            pageLength: 8,
            columnDefs: [
                { 
                    targets: [0],
                    className: "text-center", 
                    width: 20
                },
                { "width": "30%", "targets": 6 }
            ],
            oLanguage: { "sSearch": "" }, 
            language: {
                lengthMenu: "Mostrar _MENU_ registros por pagina",
                zeroRecords: "No se encontraron resultados en su busqueda",
                searchPlaceholder: "Buscar registros",
                info: "Mostrando registros de _START_ al _END_ de un total de  _TOTAL_ registros.",
                infoEmpty: "No existen registros",
                infoFiltered: "(filtrado de un total de _MAX_ registros)",
                //search: "Buscar:",
                paginate: {
                    first: "Primero",
                    last: "Último",
                    next: "Siguiente",
                    previous: "Anterior"
                },
            },
            data: JSON.parse(JSON.stringify(data)),
            columns: [
            { 
                "title": '<i class="Small material-icons">receipt</i>',
                "data": "Estado",
                "render": function (data, type, row) {
                    //return `<center><i class="Small material-icons" style="color:#00897b;" onclick="print(${row['id']},${row['tipoTransaccion']}, false, 0)">receipt</i></center>`;
                    return `<center><i class="Small material-icons" style="color:#00897b;" onclick="reprintHeaderEnvio(${row['id']})">receipt</i></center>`;
                },
            },
            { data: "tipoTransaccionTXT" },
            { data: "Estado" },
            //{ data: "serie" },
            //{ data: "correlativo" },
            { data: "fecha" },
            //{ data: "nit" },
            //{ data: "nombre" },
            /*
            { 
                "title": "Descuento",
                "data": "descuento",
                "render": function (data, type, row) {
                return accounting.formatNumber(row['descuento'],2);
                },
            },
            */
            { 
                "title": "Total",
                "data": "total",
                "render": function (data, type, row) {

                    if (row['total'] == 0){
                        return "$" + accounting.formatNumber(row['totalDolares'],2);
                    }else{
                        return "Q" + accounting.formatNumber(row['total'],2);
                    }

                },
            },
            { data: "transporte" },
            { data: "direccionEnvio" },
            { data: "transportista" },
            { data: "telefono" }
            ]
        });

        /*
        var summary = `<div>Total Ventas Q: ${accounting.formatNumber(totalQ,2)}</div>
        <div style="padding-top: 2%;">Total Ventas $: ${accounting.formatNumber(totalDolares,2)}</div>`;
        summary += `<div style="font-size:20px; padding-top: 5px;"> Total Descuentos: ${accounting.formatNumber(descuentos,2)} </div>`;
        $("#ventas").html(summary);
        */
    }, 'json').done(function(){
        });
}

function datePickerRange(){
    $('input[name="daterange"]').daterangepicker({
        startdate: new Date(), //Fecha inicial default
        endDate: new Date(), //Fecha final default
        maxDate: new Date(),
      }, function(start, end, label) {
        //console.log("A new date selection was made: " + start.format('YYYY-MM-DD') + ' to ' + end.format('YYYY-MM-DD'));
        //console.log(start.format('YYYY-MM-DD'))
        let inicio = start.format('YYYY-MM-DD');
        let fin = end.format('YYYY-MM-DD');
        envios(inicio,fin);
      });
}

//! REPRINT
function reprintHeaderEnvio(id){
	$("#headers1").empty();
	$("#facturaFoot1").empty();
	params = {
		service: "reprintFactHeader",
		dbName: dbName,
        id: id
	};
	$.post(host, params, function (data) {
		let headers = ``;
        let headerTable = ``;
		let watermark = ``;
		let summary = ``;
		let foot = ``;
		$.each(data, function (key, val) {
			if(val.autorizacionFEL === null){
				autorizacion = "N/A";
			}else{
				autorizacion = val.autorizacionFEL;
			}
            if(val.envioEspecial == 0){ //No es envio especial
				envioEspecial = `<b>GUATEMALA - FECHA: </b>${val.fechaFactura}`;
                datosFactura = `<b>SERIE:</b> ${val.serie} &emsp; &emsp; <b>DTE:</b> ${val.correlativo} </br><b> AUTORIZACION:</b> ${autorizacion} `;
			}else{
				envioEspecial = `<b>RECIBO DE ENVIO</b></br>
                <b>GUATEMALA - FECHA: </b>${val.fechaFactura}`;
                datosFactura = `</br>`;
			}
			headers += `
			<div style="display: grid;grid-template-columns: auto auto auto auto;">
				<div style="grid-column: 1 / span 2">
					<img src="assets/images/corfila.jpg" style="width: 105px; height: 100px;vertical-align: unset !important;" />
					<div style="display: inline-block;font-size: smaller;text-align: center;">
						<b style="font-size: x-large;">CORFILA S.A.</b></br>
						Corporaci&oacute;n Filadelfia, S.A.</br>
						F&aacute;brica de Bolsas y Productos Pl&aacute;sticos </br>
						17 avenida 5-46, Zona 1. Guatemala, Ciudad </br>
						Tels.: (502) 2253-3823, 253-8249/50, 2238-4901 </br>
						E-mail: ventascorfila01@gmail.com / ventas@corfila-gt.com </br>
					</div>
				</div>
				<div style="border: 1px solid;border-top-right-radius:10px;border-top-left-radius:20px;border-bottom-right-radius:10px;padding-left: 15px;padding-top: 10px;margin-top: 50px;padding-bottom: 11px;grid-column: 3 / span 2;">
				${envioEspecial} 
				</div>
				<div style="border: 1px solid;border-right:none;border-bottom: none;border-top-left-radius:10px;padding-left: 15px;grid-column: 1 / span 2;padding-left: 15px !important;padding: unset;"><b>NOMBRE:</b> ${val.nombre} <br/>
					<b>DIRECCI&Oacute;N:</b> ${val.direccionEnvio}
				</div>
				<div style="border: 1px solid;border-left:none;border-bottom: none;border-top-right-radius:10px;padding-left: 15px !important;padding: unset;grid-column: 4 ;">
					<b>NIT:</b> ${val.nit} </br>
					<b>TEL:</b> ${val.telefono}
				</div>
				<div style="border-left: 1px solid;border-top: none;padding-left: 15px !important;padding: unset;grid-column: 1 / span 2;">
					${datosFactura}
				</div>
				<div style="border-right: 1px solid;border-top: none;padding-left: 15px !important;padding: unset;grid-column: 3 / span 2 ;">
					<b>PEDIDO No.:</b> ${val.pedido}
				</div>
				<div style="border: 1px solid;border-bottom-left-radius:20px;border-right: none;border-top: none;padding-left: 15px !important;padding: unset;grid-column: 1 / span 2;">
					<b>TRANSPORTE: </b> ${val.transporte}
				</div>
				<div style="border: 1px solid;border-bottom-right-radius:20px;border-left: none;border-top: none;padding-left: 15px !important;padding: unset;grid-column: 3 / span 2 ;">
					<b>CANTIDAD DE BULTOS:</b> ${val.cantBultos}
				</div>
			</div>	
			`;

            if (val.tipoEnvio == '1'){
				summary += `<tr>
				<td colspan="3" style="padding-left: 15px;"><b>EN LETRAS: </b></br> ${val.totalEnLetras}</td>
				<td style="font-size: large;text-align:right;"><b>Total Q</b></td>
				<td style="padding-right: 15px;font-size: large;"><b>${accounting.formatNumber(val.total,2)}</b></td>
			</tr>
			`;
			}else{
				summary += `<tr>
				<td colspan="3" style="padding-left: 15px;"><b>EN LETRAS:</b></br></td>
				<td style="font-size: large;text-align:right;"><b>Total Q</b></td>
				<td style="padding-right: 15px;font-size: large;"><b>0.00</b></td>
				</tr>
			`;
			}
			foot += `<div style="text-align: center;margin-top: 20px;font-size: smaller;"><pre><b>ENTREGO: </b>${val.transportista}<b>	RECIB&Iacute:</b>_____________________________</pre></div>
			`;
            watermark += `<img src="assets/images/corfila.jpg" style="height: 30%;display: block;margin-left: auto;margin-right: auto;width: 30%;margin-top: 220px;"/>`;
            headerTable += `
            <tr>
                <th>CANTIDAD</th>
                <th>CONTENIDO</th>
                <th style="text-align: center;">FARDOS</th>
                <th style="text-align: center;">DESCUENTO</th>
                <th style="text-align: center;">VALOR</th>
            </tr>`;
		});
        //console.log(headers);
		$("#headers1").html(headers);
        $("#watermark").html(watermark);
        $("#bodyTable1 thead").html(headerTable);
		$("#bodyTable1 tfoot").html(summary);
		$("#facturaFoot1").html(foot);
	}, "json").done(function(){
		reprintDetallesFactura(id);
	});
}

function reprintDetallesFactura(id){
	$("#bodyTable1 tbody").empty();
	params = {
		service: "reprintFactDetail",
		dbName: dbName,
        id: id
	};
	$.post(host, params, function (data) {
		let table = ``;
		var total = 0;
		
		$.each(data, function (key, val) {
            if (val.tipoEnvio == '1'){
				totales = val.total;
                descuentos = val.descuento;
			}else{
				totales = "0.00";
                descuentos = "0.00";
			}
			total += accounting.unformat(val.total);
			table += `
            <tr>
                <td style="padding-left: 15px">${val.cantidad}</td>
                <td>${val.descLarga}</td>
                <td style="text-align: center;">${val.cantFardos}</td>
                <td style="text-align: center;">${descuentos}</td>
                <td style="text-align: center;">${totales}</td>
            </tr>`;
		});
		$("#bodyTable1 tbody").html(table);		
	}, "json").done(function(){    
        //$("#modalFactura").modal("open");
        window.print();
	});
}

function cerrarModalF() {
	$("#modalFactura").modal("close");
}

